diff -uNrp linux-2.6.14.5/kernel/ltt-facilities.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/ltt-facilities.c
--- linux-2.6.14.5/kernel/ltt-facilities.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/ltt-facilities.c	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,227 @@
+/*
+ * ltt-facilities.c
+ *
+ * (C) Copyright	2005 -
+ * 							Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
+ *
+ * Contains the kernel core code for Linux Trace Toolkit facilities.
+ *
+ * Facilities are a group of events that can be recorded by instrumentation
+ * points to a trace. We keep track of the active facilities to know which type
+ * of information can be present in a trace.
+ *
+ * We never reuse a facility id.
+ * 
+ * Author:
+ *	Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
+ *
+ */
+
+#include <linux/ltt/ltt-facility-core.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/ltt-facilities.h>
+#include <linux/spinlock.h>
+#include <linux/string.h>
+
+enum ltt_facility_type 	{ LTT_FACILITY_BUILTIN,
+													LTT_FACILITY_DYNAMIC_REGISTERED,
+													LTT_FACILITY_DYNAMIC_UNREGISTERED };
+
+struct ltt_facility_info {
+  int exist;  /* Is the facility field used ? */
+	struct ltt_facility *facility;
+	enum ltt_facility_type type;
+  size_t alignment;
+};
+
+static struct ltt_facility_info facilities[LTT_MAX_NUM_FACILITIES];
+static spinlock_t	facilities_lock;
+
+static inline int ltt_facility_register(enum ltt_facility_type type,
+																				struct ltt_facility *facility,
+																				size_t int_size,
+																				size_t long_size,
+																				size_t pointer_size,
+																				size_t size_t_size)
+{
+	int fac_id;
+	size_t alignment;
+  
+	spin_lock(&facilities_lock);
+
+#ifdef CONFIG_LTT_ALIGNMENT
+	alignment = sizeof(void*);
+#else
+	alignment = 0;
+#endif
+
+	if(strcmp(facility->name, "core") == 0) {
+		fac_id = 0;
+		facilities[fac_id].facility = facility;
+		facilities[fac_id].type = type;
+    facilities[fac_id].exist = 1;
+    facilities[fac_id].alignment = alignment;
+  } else {
+    for(fac_id=LTT_RESERVED_FACILITIES;fac_id<LTT_MAX_NUM_FACILITIES;fac_id++)
+      if(facilities[fac_id].exist == 0)
+        break;
+    if(fac_id == LTT_MAX_NUM_FACILITIES) {
+      fac_id = -EPERM;
+      goto unlock;
+    }
+		facilities[fac_id].facility = facility;
+		facilities[fac_id].type = type;
+    facilities[fac_id].exist = 1;
+    facilities[fac_id].alignment = alignment;
+	}
+
+	trace_core_facility_load(
+			facility->name,
+			facility->checksum,
+			fac_id,
+			(u32)int_size,
+			(u32)long_size,
+			(u32)pointer_size,
+			(u32)size_t_size,
+			alignment);
+
+unlock:
+	
+	spin_unlock(&facilities_lock);
+	return fac_id;
+}
+
+
+int ltt_facility_builtin_register(struct ltt_facility *facility)
+{
+	return ltt_facility_register(LTT_FACILITY_BUILTIN, facility,
+			sizeof(int), sizeof(long), sizeof(void*), sizeof(size_t));
+}
+
+int ltt_facility_dynamic_register(struct ltt_facility *facility)
+{
+	return ltt_facility_register(LTT_FACILITY_DYNAMIC_REGISTERED, facility,
+			sizeof(int), sizeof(long), sizeof(void*), sizeof(size_t));
+}
+
+int ltt_facility_dynamic_unregister(ltt_facility_t facility_id)
+{
+	int ret;
+
+	spin_lock(&facilities_lock);
+  
+	if(facilities[facility_id].exist == 0) {
+		ret = -EPERM;
+		goto unlock;
+	}
+	
+	if(facilities[facility_id].type != LTT_FACILITY_DYNAMIC_REGISTERED) {
+		ret = -EPERM;
+		goto unlock;
+	}
+	
+	facilities[facility_id].facility = NULL;
+	facilities[facility_id].type = LTT_FACILITY_DYNAMIC_UNREGISTERED;
+
+	/* Disable preemption because we read the traces list, and want it to be
+	 * RCU coherent. */
+	preempt_disable();
+	ltt_nesting[smp_processor_id()]++;
+	barrier();
+
+	/* If no more trace in the list, we can free the unused facility,
+	 * otherwise it will be freed laster when the last trace is destroyed (by
+	 * ltt_facility_free_unused()). */
+  if(list_empty(&ltt_traces.head))
+	  facilities[facility_id].exist = 0;
+
+	barrier();
+	ltt_nesting[smp_processor_id()]--;
+	preempt_enable();
+
+	trace_core_facility_unload(facility_id);
+
+	ret = 0;
+
+unlock:
+	
+	spin_unlock(&facilities_lock);
+	return ret;
+}
+
+/* Cleanup all the unregistered facilities. This must be done when all the
+ * traces are destroyed.
+ */
+void ltt_facility_free_unused(void)
+{
+  int fac_id;
+  
+  for(fac_id=LTT_RESERVED_FACILITIES;fac_id<LTT_MAX_NUM_FACILITIES;fac_id++)
+		if(facilities[fac_id].type == LTT_FACILITY_DYNAMIC_UNREGISTERED)
+			facilities[fac_id].exist = 0;
+}
+
+
+void ltt_facility_state_dump(struct ltt_trace_struct *trace)
+{
+	int fac_id;
+	struct ltt_facility *facility;
+	u32 int_size, long_size, pointer_size, size_t_size;
+
+  int_size = sizeof(int);
+  long_size = sizeof(long);
+  pointer_size = sizeof(void*);
+  size_t_size = sizeof(size_t);
+
+	spin_lock(&facilities_lock);
+
+	for(fac_id=0;fac_id<LTT_MAX_NUM_FACILITIES;fac_id++) {
+    if(facilities[fac_id].exist) {
+      facility = facilities[fac_id].facility;
+      printk(KERN_INFO "Dumping facility %s\n",
+          facility->name);
+      switch(facilities[fac_id].type) {
+        case LTT_FACILITY_DYNAMIC_REGISTERED:
+        case LTT_FACILITY_BUILTIN:
+          trace_core_state_dump_facility_load(trace,
+              facility->name,
+              facility->checksum,
+              fac_id,
+              (u32)int_size,
+              (u32)long_size,
+              (u32)pointer_size,
+              (u32)size_t_size,
+              facilities[fac_id].alignment);
+          break;
+        case LTT_FACILITY_DYNAMIC_UNREGISTERED:
+          break;
+      }
+    }
+	}
+	spin_unlock(&facilities_lock);
+}
+
+
+EXPORT_SYMBOL(ltt_facility_builtin_register);
+
+EXPORT_SYMBOL(ltt_facility_dynamic_register);
+EXPORT_SYMBOL(ltt_facility_dynamic_unregister);
+
+EXPORT_SYMBOL(ltt_facility_free_unused);
+
+EXPORT_SYMBOL(ltt_facility_state_dump);
+
+static int __init ltt_facilities_init(void)
+{
+  int i;
+	printk(KERN_INFO "LTT : ltt-facilities init\n");
+
+	spin_lock_init(&facilities_lock);
+  for(i=0; i<LTT_MAX_NUM_FACILITIES; i++)
+    facilities[i].exist = 0;
+  
+	return 0;
+}
+__initcall(ltt_facilities_init);
+
diff -uNrp linux-2.6.14.5/kernel/Makefile linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/Makefile
--- linux-2.6.14.5/kernel/Makefile	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/Makefile	2006-01-22 13:01:14.000000000 +0100
@@ -9,6 +9,10 @@ obj-y     = sched.o fork.o exec_domain.o
 	    rcupdate.o intermodule.o extable.o params.o posix-timers.o \
 	    kthread.o wait.o kfifo.o sys_ni.o posix-cpu-timers.o
 
+ifeq ($(CONFIG_LTT),y)
+	obj-y += ltt-base.o
+endif
+
 obj-$(CONFIG_FUTEX) += futex.o
 obj-$(CONFIG_GENERIC_ISA_DMA) += dma.o
 obj-$(CONFIG_SMP) += cpu.o spinlock.o
@@ -19,6 +23,8 @@ obj-$(CONFIG_KALLSYMS) += kallsyms.o
 obj-$(CONFIG_PM) += power/
 obj-$(CONFIG_BSD_PROCESS_ACCT) += acct.o
 obj-$(CONFIG_KEXEC) += kexec.o
+obj-$(CONFIG_LTT) += ltt-facilities.o
+obj-$(CONFIG_LTT_TRACER) += ltt-core.o
 obj-$(CONFIG_COMPAT) += compat.o
 obj-$(CONFIG_CPUSETS) += cpuset.o
 obj-$(CONFIG_IKCONFIG) += configs.o
@@ -32,6 +38,7 @@ obj-$(CONFIG_DETECT_SOFTLOCKUP) += softl
 obj-$(CONFIG_GENERIC_HARDIRQS) += irq/
 obj-$(CONFIG_CRASH_DUMP) += crash_dump.o
 obj-$(CONFIG_SECCOMP) += seccomp.o
+obj-$(CONFIG_IPIPE) += ipipe/
 
 ifneq ($(CONFIG_SCHED_NO_NO_OMIT_FRAME_POINTER),y)
 # According to Alan Modra <alan@linuxcare.com.au>, the -fno-omit-frame-pointer is
@@ -55,3 +62,4 @@ quiet_cmd_ikconfiggz = IKCFG   $@
 targets += config_data.h
 $(obj)/config_data.h: $(obj)/config_data.gz FORCE
 	$(call if_changed,ikconfiggz)
+
diff -uNrp linux-2.6.14.5/kernel/printk.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/printk.c
--- linux-2.6.14.5/kernel/printk.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/printk.c	2006-01-22 13:01:14.000000000 +0100
@@ -507,6 +507,78 @@ __attribute__((weak)) unsigned long long
  * is inspected when the actual printing occurs.
  */
 
+#ifdef CONFIG_IPIPE
+
+static ipipe_spinlock_t __ipipe_printk_lock = IPIPE_SPIN_LOCK_UNLOCKED;
+
+static int __ipipe_printk_fill;
+
+static char __ipipe_printk_buf[__LOG_BUF_LEN];
+
+void __ipipe_flush_printk (unsigned virq)
+{
+	char *p = __ipipe_printk_buf;
+	int len, lmax, out = 0;
+	unsigned long flags;
+
+	goto start;
+
+	do {
+		spin_unlock_irqrestore_hw(&__ipipe_printk_lock,flags);
+ start:
+		lmax = __ipipe_printk_fill;
+		while (out < lmax) {
+			len = strlen(p) + 1;
+			printk("%s",p);
+			p += len;
+			out += len;
+		}
+		spin_lock_irqsave_hw(&__ipipe_printk_lock,flags);
+	}
+	while (__ipipe_printk_fill != lmax);
+
+	__ipipe_printk_fill = 0;
+
+	spin_unlock_irqrestore_hw(&__ipipe_printk_lock,flags);
+}
+
+asmlinkage int printk(const char *fmt, ...)
+{
+	int r, fbytes, oldcount;
+    	unsigned long flags;
+	va_list args;
+
+	va_start(args, fmt);
+
+	if (ipipe_current_domain == ipipe_root_domain ||
+	    test_bit(IPIPE_SPRINTK_FLAG,&ipipe_current_domain->flags) ||
+	    oops_in_progress) {
+		r = vprintk(fmt, args);
+		goto out;
+	}
+
+	spin_lock_irqsave_hw(&__ipipe_printk_lock,flags);
+
+	oldcount = __ipipe_printk_fill;
+	fbytes = __LOG_BUF_LEN - oldcount;
+
+	if (fbytes > 1)	{
+		r = vscnprintf(__ipipe_printk_buf + __ipipe_printk_fill,
+			       fbytes, fmt, args) + 1; /* account for the null byte */
+		__ipipe_printk_fill += r;
+	} else
+		r = 0;
+
+	spin_unlock_irqrestore_hw(&__ipipe_printk_lock,flags);
+
+	if (oldcount == 0)
+		ipipe_trigger_irq(__ipipe_printk_virq);
+out: 
+	va_end(args);
+
+	return r;
+}
+#else /* !CONFIG_IPIPE */
 asmlinkage int printk(const char *fmt, ...)
 {
 	va_list args;
@@ -518,6 +590,7 @@ asmlinkage int printk(const char *fmt, .
 
 	return r;
 }
+#endif /* CONFIG_IPIPE */
 
 /* cpu currently holding logbuf_lock */
 static volatile unsigned int printk_cpu = UINT_MAX;
diff -uNrp linux-2.6.14.5/kernel/sched.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/sched.c
--- linux-2.6.14.5/kernel/sched.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/sched.c	2006-01-22 13:01:14.000000000 +0100
@@ -18,6 +18,7 @@
  *  2004-04-02	Scheduler domains code by Nick Piggin
  */
 
+#include <linux/ltt/ltt-facility-process.h>
 #include <linux/mm.h>
 #include <linux/module.h>
 #include <linux/nmi.h>
@@ -355,6 +356,8 @@ static inline runqueue_t *task_rq_lock(t
 {
 	struct runqueue *rq;
 
+	trace_process_wakeup(p->pid, p->state);
+
 repeat_lock_task:
 	local_irq_save(*flags);
 	rq = task_rq(p);
@@ -2855,6 +2858,11 @@ asmlinkage void __sched schedule(void)
 	unsigned long run_time;
 	int cpu, idx, new_prio;
 
+#ifdef CONFIG_IPIPE
+	if (unlikely(ipipe_current_domain != ipipe_root_domain)) {
+		goto need_resched;
+	}
+#endif /* CONFIG_IPIPE */
 	/*
 	 * Test if we are atomic.  Since do_exit() needs to call into
 	 * schedule() atomically, we ignore that path for now.
@@ -2872,6 +2880,12 @@ asmlinkage void __sched schedule(void)
 
 need_resched:
 	preempt_disable();
+#ifdef CONFIG_IPIPE
+	if (unlikely(ipipe_current_domain != ipipe_root_domain)) {
+		preempt_enable();
+		return;
+	}
+#endif /* CONFIG_IPIPE */
 	prev = current;
 	release_kernel_lock(prev);
 need_resched_nonpreemptible:
@@ -3008,8 +3022,11 @@ switch_tasks:
 		++*switch_count;
 
 		prepare_task_switch(rq, next);
+		trace_process_schedchange(prev->pid, next->pid, prev->state);
 		prev = context_switch(rq, prev, next);
 		barrier();
+ 		if (task_hijacked(prev))
+ 		    return;
 		/*
 		 * this_rq must be evaluated again because prev may have moved
 		 * CPUs since it called schedule(), thus the 'rq' on its stack
@@ -3042,6 +3059,11 @@ asmlinkage void __sched preempt_schedule
 	struct task_struct *task = current;
 	int saved_lock_depth;
 #endif
+#ifdef CONFIG_IPIPE
+	/* Do not reschedule over non-Linux domains. */
+	if (ipipe_current_domain != ipipe_root_domain)
+		return;
+#endif /* CONFIG_IPIPE */
 	/*
 	 * If there is a non-zero preempt_count or interrupts are disabled,
 	 * we do not want to preempt the current task.  Just return..
@@ -3670,6 +3692,7 @@ recheck:
 		deactivate_task(p, rq);
 	oldprio = p->prio;
 	__setscheduler(p, policy, param->sched_priority);
+	ipipe_setsched_notify(p);
 	if (array) {
 		__activate_task(p, rq);
 		/*
@@ -5647,3 +5670,53 @@ void set_curr_task(int cpu, task_t *p)
 }
 
 #endif
+
+#ifdef CONFIG_IPIPE
+
+int ipipe_setscheduler_root (struct task_struct *p, int policy, int prio)
+{
+	prio_array_t *array;
+	unsigned long flags;
+	runqueue_t *rq;
+	int oldprio;
+
+	if (prio < 1 || prio > MAX_RT_PRIO-1)
+		return -EINVAL;
+
+	rq = task_rq_lock(p, &flags);
+	array = p->array;
+	if (array)
+		deactivate_task(p, rq);
+	oldprio = p->prio;
+	__setscheduler(p, policy, prio);
+	if (array) {
+		__activate_task(p, rq);
+		if (task_running(rq, p)) {
+			if (p->prio > oldprio)
+				resched_task(rq->curr);
+		} else if (TASK_PREEMPTS_CURR(p, rq))
+			resched_task(rq->curr);
+	}
+	task_rq_unlock(rq, &flags);
+
+	return 0;
+}
+
+EXPORT_SYMBOL(ipipe_setscheduler_root);
+
+int ipipe_reenter_root (struct task_struct *prev, int policy, int prio)
+{
+	finish_task_switch(this_rq(), prev);
+	if (reacquire_kernel_lock(current) < 0)
+		;
+	preempt_enable_no_resched();
+
+	if (current->policy != policy || current->rt_priority != prio)
+		return ipipe_setscheduler_root(current,policy,prio);
+
+	return 0;
+}
+
+EXPORT_SYMBOL(ipipe_reenter_root);
+
+#endif /* CONFIG_IPIPE */
diff -uNrp linux-2.6.14.5/kernel/signal.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/signal.c
--- linux-2.6.14.5/kernel/signal.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/signal.c	2006-01-22 13:01:14.000000000 +0100
@@ -10,6 +10,7 @@
  *		to allow signals to be sent reliably.
  */
 
+#include <linux/ltt/ltt-facility-process.h>
 #include <linux/config.h>
 #include <linux/slab.h>
 #include <linux/module.h>
@@ -603,6 +604,7 @@ void signal_wake_up(struct task_struct *
 	unsigned int mask;
 
 	set_tsk_thread_flag(t, TIF_SIGPENDING);
+	ipipe_sigwake_notify(t); /* TIF_SIGPENDING must be set first. */
 
 	/*
 	 * For SIGKILL, we want to wake it up in the stopped/traced case.
@@ -869,6 +871,8 @@ specific_send_sig_info(int sig, struct s
 	if (sig_ignored(t, sig))
 		goto out;
 
+	trace_process_signal(t->pid, sig);
+
 	/* Support queueing exactly one non-rt signal, so that we
 	   can get more detailed information about the cause of
 	   the signal. */
diff -uNrp linux-2.6.14.5/kernel/softirq.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/softirq.c
--- linux-2.6.14.5/kernel/softirq.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/softirq.c	2006-01-22 13:01:14.000000000 +0100
@@ -6,6 +6,7 @@
  * Rewritten. Old one was good in 2.2, but in 2.3 it was immoral. --ANK (990903)
  */
 
+#include <linux/ltt/ltt-facility-kernel.h>
 #include <linux/module.h>
 #include <linux/kernel_stat.h>
 #include <linux/interrupt.h>
@@ -92,7 +93,9 @@ restart:
 
 	do {
 		if (pending & 1) {
+			trace_kernel_soft_irq_entry((void*)(h - softirq_vec));
 			h->action(h);
+			trace_kernel_soft_irq_exit((void*)(h - softirq_vec));
 			rcu_bh_qsctr_inc(cpu);
 		}
 		h++;
@@ -262,9 +265,17 @@ static void tasklet_action(struct softir
 
 		if (tasklet_trylock(t)) {
 			if (!atomic_read(&t->count)) {
-				if (!test_and_clear_bit(TASKLET_STATE_SCHED, &t->state))
+				if (!test_and_clear_bit(TASKLET_STATE_SCHED,
+						&t->state))
 					BUG();
+
+				trace_kernel_tasklet_entry(LTTNG_LOW, t->func, t->data);
+
 				t->func(t->data);
+
+				trace_kernel_tasklet_exit(LTTNG_LOW, t->func, t->data);
+
+
 				tasklet_unlock(t);
 				continue;
 			}
@@ -295,9 +306,15 @@ static void tasklet_hi_action(struct sof
 
 		if (tasklet_trylock(t)) {
 			if (!atomic_read(&t->count)) {
-				if (!test_and_clear_bit(TASKLET_STATE_SCHED, &t->state))
+				if (!test_and_clear_bit(TASKLET_STATE_SCHED,
+						&t->state))
 					BUG();
+
+				trace_kernel_tasklet_entry(LTTNG_HIGH, t->func, t->data);
+
 				t->func(t->data);
+
+				trace_kernel_tasklet_exit(LTTNG_HIGH, t->func, t->data);
 				tasklet_unlock(t);
 				continue;
 			}
diff -uNrp linux-2.6.14.5/kernel/timer.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/timer.c
--- linux-2.6.14.5/kernel/timer.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/timer.c	2006-01-22 13:01:14.000000000 +0100
@@ -19,6 +19,7 @@
  *              Designed by David S. Miller, Alexey Kuznetsov and Ingo Molnar
  */
 
+#include <linux/ltt/ltt-facility-timer.h>
 #include <linux/kernel_stat.h>
 #include <linux/module.h>
 #include <linux/interrupt.h>
@@ -912,6 +913,8 @@ static void run_timer_softirq(struct sof
 {
 	tvec_base_t *base = &__get_cpu_var(tvec_bases);
 
+	trace_timer_softirq();
+
 	if (time_after_eq(jiffies, base->timer_jiffies))
 		__run_timers(base);
 }
@@ -1071,6 +1074,7 @@ asmlinkage long sys_getegid(void)
 
 static void process_timeout(unsigned long __data)
 {
+	trace_timer_expired(((task_t *)__data)->pid);
 	wake_up_process((task_t *)__data);
 }
 
diff -uNrp linux-2.6.14.5/lib/smp_processor_id.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/lib/smp_processor_id.c
--- linux-2.6.14.5/lib/smp_processor_id.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/lib/smp_processor_id.c	2006-01-22 13:01:14.000000000 +0100
@@ -12,6 +12,11 @@ unsigned int debug_smp_processor_id(void
 	int this_cpu = raw_smp_processor_id();
 	cpumask_t this_mask;
 
+#ifdef CONFIG_IPIPE
+ 	if (ipipe_current_domain != ipipe_root_domain)
+	    return this_cpu;
+#endif /* CONFIG_IPIPE */
+
 	if (likely(preempt_count))
 		goto out;
 
diff -uNrp linux-2.6.14.5/lib/spinlock_debug.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/lib/spinlock_debug.c
--- linux-2.6.14.5/lib/spinlock_debug.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/lib/spinlock_debug.c	2006-01-22 13:01:14.000000000 +0100
@@ -10,6 +10,7 @@
 #include <linux/spinlock.h>
 #include <linux/interrupt.h>
 #include <linux/delay.h>
+#include <linux/module.h>
 
 static void spin_bug(spinlock_t *lock, const char *msg)
 {
@@ -93,6 +94,8 @@ void _raw_spin_lock(spinlock_t *lock)
 	debug_spin_lock_after(lock);
 }
 
+EXPORT_SYMBOL(_raw_spin_lock);
+
 int _raw_spin_trylock(spinlock_t *lock)
 {
 	int ret = __raw_spin_trylock(&lock->raw_lock);
@@ -108,12 +111,16 @@ int _raw_spin_trylock(spinlock_t *lock)
 	return ret;
 }
 
+EXPORT_SYMBOL(_raw_spin_trylock);
+
 void _raw_spin_unlock(spinlock_t *lock)
 {
 	debug_spin_unlock(lock);
 	__raw_spin_unlock(&lock->raw_lock);
 }
 
+EXPORT_SYMBOL(_raw_spin_unlock);
+
 static void rwlock_bug(rwlock_t *lock, const char *msg)
 {
 	static long print_once = 1;
@@ -162,6 +169,8 @@ void _raw_read_lock(rwlock_t *lock)
 		__read_lock_debug(lock);
 }
 
+EXPORT_SYMBOL(_raw_read_lock);
+
 int _raw_read_trylock(rwlock_t *lock)
 {
 	int ret = __raw_read_trylock(&lock->raw_lock);
@@ -175,12 +184,16 @@ int _raw_read_trylock(rwlock_t *lock)
 	return ret;
 }
 
+EXPORT_SYMBOL(_raw_read_trylock);
+
 void _raw_read_unlock(rwlock_t *lock)
 {
 	RWLOCK_BUG_ON(lock->magic != RWLOCK_MAGIC, lock, "bad magic");
 	__raw_read_unlock(&lock->raw_lock);
 }
 
+EXPORT_SYMBOL(_raw_read_unlock);
+
 static inline void debug_write_lock_before(rwlock_t *lock)
 {
 	RWLOCK_BUG_ON(lock->magic != RWLOCK_MAGIC, lock, "bad magic");
@@ -235,6 +248,8 @@ void _raw_write_lock(rwlock_t *lock)
 	debug_write_lock_after(lock);
 }
 
+EXPORT_SYMBOL(_raw_write_lock);
+
 int _raw_write_trylock(rwlock_t *lock)
 {
 	int ret = __raw_write_trylock(&lock->raw_lock);
@@ -250,8 +265,12 @@ int _raw_write_trylock(rwlock_t *lock)
 	return ret;
 }
 
+EXPORT_SYMBOL(_raw_write_trylock);
+
 void _raw_write_unlock(rwlock_t *lock)
 {
 	debug_write_unlock(lock);
 	__raw_write_unlock(&lock->raw_lock);
 }
+
+EXPORT_SYMBOL(_raw_write_unlock);
diff -uNrp linux-2.6.14.5/ltt/Kconfig linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/Kconfig
--- linux-2.6.14.5/ltt/Kconfig	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/Kconfig	2006-01-22 13:02:25.000000000 +0100
@@ -0,0 +1,160 @@
+menu "Instrumentation Support"
+
+config LTT
+	bool "Linux Trace Toolkit Instrumentation Support"
+	select RELAYFS_FS
+	select LTT_FACILITY_CORE
+	depends on !X86_64 && EXPERIMENTAL
+	default n
+	help
+	  It is possible for the kernel to log important events to a trace
+	  facility. Doing so, enables the use of the generated traces in order
+	  to reconstruct the dynamic behavior of the kernel, and hence the
+	  whole system.
+
+	  The tracing process contains 4 parts :
+	      1) The logging of events by key parts of the kernel.
+	      2) The tracer that keeps the events in a data buffer (uses
+	         relayfs).
+	      3) A trace daemon that interacts with the tracer and is
+	         notified every time there is a certain quantity of data to
+	         read from the tracer.
+	      4) A trace event data decoder that reads the accumulated data
+	         and formats it in a human-readable format.
+
+	  If you say Y, the first component will be built into the kernel.
+
+	  For more information on kernel tracing, the trace daemon or the event
+	  decoder, please check the following address :
+	       http://www.opersys.com/ltt
+	  See also the experimental page of the project :
+	       http://ltt.polymtl.ca
+
+config LTT_TRACER
+	tristate "Linux Trace Toolkit Tracer"
+	select RELAYFS_FS
+	depends on LTT
+	default y
+	help
+	  If you enable this option, the Linux Trace Toolkit Tracer will be
+	  either built in the kernel of as module.
+
+	  Critical parts of the kernel will call upon the kernel tracing
+	  function. The data is then recorded by the tracer if a trace daemon
+	  is running in user-space and has issued a "start" command.
+
+	  For more information on kernel tracing, the trace daemon or the event
+	  decoder, please check the following address :
+	       http://www.opersys.com/ltt
+	  See also the experimental page of the project :
+	       http://ltt.polymtl.ca
+
+config LTT_ALIGNMENT
+	bool "Align Linux Trace Toolkit Traces"
+	depends on LTT
+	default y
+	help
+		This option enables dynamic alignment of data in buffers. The alignment
+		is made on the smallest size between architecture size and the size of
+		the value to be written.
+
+		Dynamically calculating the offset of the data has a performance cost,
+		but it is more efficient on some architectures (especially 64 bits) to
+		align data than to write it unaligned.
+
+config LTT_HEARTBEAT
+	bool "Activate Linux Trace Toolkit Heartbeat Timer"
+	depends on LTT
+	default n
+	help
+		The Linux Trace Toolkit Heartbeat Timer fires at an interval small
+		enough to guarantee that the 32 bits truncated TSC won't overflow
+		between two consecutive events in a trace. It simply write an event
+		in each tracefiles at an interval that is one tenth of the time it
+		takes to overflow 32 bits at your CPU frequency.
+
+		If there is no Heartbeat Timer activated, 64 bits fields must be
+		used in each event header to save the full TSC : it can make traces
+		about 1/10 bigger.
+
+		It is suggested that you enable this option to make more compact
+		traces.
+
+config LTT_FACILITY_CORE
+	bool "Linux Trace Toolkit Core Facility"
+	depends on LTT
+	default y
+	help
+		LTT core facility. Contains event definition for facility load/unload and
+		heartbeat.
+
+config LTT_FACILITY_FS
+	bool "Linux Trace Toolkit File System Facility"
+	depends on LTT
+	default y
+	help
+		LTT file system facility. Contains event definition for filesystem related
+		events.
+
+config LTT_FACILITY_IPC
+	bool "Linux Trace Toolkit Inter-Process Communication Facility"
+	depends on LTT
+	default y
+	help
+		LTT IPC facility. Contains event definition for inter-process communication
+		events.
+
+config LTT_FACILITY_KERNEL
+	bool "Linux Trace Toolkit Kernel Facility"
+	depends on LTT
+	default y
+	help
+		LTT Kernel facility. Contains event definition for tasklet, irq, system
+		calls, traps, soft irq events.
+
+config LTT_FACILITY_MEMORY
+	bool "Linux Trace Toolkit Memory Facility"
+	depends on LTT
+	default y
+	help
+		LTT Memory facility. Contains event definition for memory management related
+		events.
+
+config LTT_FACILITY_NETWORK
+	bool "Linux Trace Toolkit Network Facility"
+	depends on LTT
+	default y
+	help
+		LTT Network facility. Contains event definition for network subsystem.
+
+config LTT_FACILITY_PROCESS
+	bool "Linux Trace Toolkit Process Facility"
+	depends on LTT
+	default y
+	help
+		LTT Process facility. Contains event definition for process management and
+		scheduling.
+
+config LTT_FACILITY_SOCKET
+	bool "Linux Trace Toolkit Socket Facility"
+	depends on LTT
+	default y
+	help
+		LTT Socket facility. Contains event definition for sockets.
+
+config LTT_FACILITY_STATEDUMP
+	bool "Linux Trace Toolkit Kernel State Dump Facility"
+	depends on LTT
+	default y
+	help
+		LTT Kernel State Dump facility. Contains events for dumping kernel state at
+		the beginning of a trace.
+
+config LTT_FACILITY_TIMER
+	bool "Linux Trace Toolkit Timer Facility"
+	depends on LTT
+	default y
+	help
+		LTT Timer facility. Contains events for timers.
+
+endmenu
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-core.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-core.c
--- linux-2.6.14.5/ltt/ltt-facility-loader-core.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-core.c	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,86 @@
+/*
+ * ltt-facility-loader-core.c
+ *
+ * (C) Copyright  2005 - 
+ *          Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
+ *
+ * Contains the LTT facility loader.
+ *
+ */
+
+
+#include <linux/ltt-facilities.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/config.h>
+#include "ltt-facility-loader-core.h"
+
+
+#ifdef CONFIG_LTT
+
+EXPORT_SYMBOL(LTT_FACILITY_SYMBOL);
+EXPORT_SYMBOL(LTT_FACILITY_CHECKSUM_SYMBOL);
+
+static const char ltt_facility_name[] = LTT_FACILITY_NAME;
+
+#define SYMBOL_STRING(sym) #sym
+
+static struct ltt_facility facility = {
+	.name = ltt_facility_name,
+	.num_events = LTT_FACILITY_NUM_EVENTS,
+	.checksum = LTT_FACILITY_CHECKSUM,
+	.symbol = SYMBOL_STRING(LTT_FACILITY_SYMBOL),
+};
+
+#ifndef MODULE
+
+/* Built-in facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-core init in kernel\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_builtin_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+	
+	return LTT_FACILITY_SYMBOL;
+}
+__initcall(facility_init);
+
+
+
+#else 
+
+/* Dynamic facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-core init dynamic\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_dynamic_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+
+	return LTT_FACILITY_SYMBOL;
+}
+
+static void __exit facility_exit(void)
+{
+	int err;
+
+	err = ltt_facility_dynamic_unregister(LTT_FACILITY_SYMBOL);
+	if(err != 0)
+		printk(KERN_ERR "LTT : Error in unregistering facility.\n");
+
+}
+
+module_init(facility_init)
+module_exit(facility_exit)
+
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION("Linux Trace Toolkit Facility");
+
+#endif //MODULE
+
+#endif //CONFIG_LTT
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-core.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-core.h
--- linux-2.6.14.5/ltt/ltt-facility-loader-core.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-core.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,20 @@
+#ifndef _LTT_FACILITY_LOADER_CORE_H_
+#define _LTT_FACILITY_LOADER_CORE_H_
+
+#ifdef CONFIG_LTT
+
+#include <linux/ltt-facilities.h>
+#include <linux/ltt/ltt-facility-id-core.h>
+
+ltt_facility_t	ltt_facility_core;
+ltt_facility_t	ltt_facility_core_F1C514F;
+
+#define LTT_FACILITY_SYMBOL							ltt_facility_core
+#define LTT_FACILITY_CHECKSUM_SYMBOL		ltt_facility_core_F1C514F
+#define LTT_FACILITY_CHECKSUM						0xF1C514F
+#define LTT_FACILITY_NAME								"core"
+#define LTT_FACILITY_NUM_EVENTS					facility_core_num_events
+
+#endif //CONFIG_LTT
+
+#endif //_LTT_FACILITY_LOADER_CORE_H_
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-fs.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-fs.c
--- linux-2.6.14.5/ltt/ltt-facility-loader-fs.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-fs.c	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,86 @@
+/*
+ * ltt-facility-loader-fs.c
+ *
+ * (C) Copyright  2005 - 
+ *          Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
+ *
+ * Contains the LTT facility loader.
+ *
+ */
+
+
+#include <linux/ltt-facilities.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/config.h>
+#include "ltt-facility-loader-fs.h"
+
+
+#ifdef CONFIG_LTT
+
+EXPORT_SYMBOL(LTT_FACILITY_SYMBOL);
+EXPORT_SYMBOL(LTT_FACILITY_CHECKSUM_SYMBOL);
+
+static const char ltt_facility_name[] = LTT_FACILITY_NAME;
+
+#define SYMBOL_STRING(sym) #sym
+
+static struct ltt_facility facility = {
+	.name = ltt_facility_name,
+	.num_events = LTT_FACILITY_NUM_EVENTS,
+	.checksum = LTT_FACILITY_CHECKSUM,
+	.symbol = SYMBOL_STRING(LTT_FACILITY_SYMBOL),
+};
+
+#ifndef MODULE
+
+/* Built-in facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-fs init in kernel\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_builtin_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+	
+	return LTT_FACILITY_SYMBOL;
+}
+__initcall(facility_init);
+
+
+
+#else 
+
+/* Dynamic facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-fs init dynamic\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_dynamic_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+
+	return LTT_FACILITY_SYMBOL;
+}
+
+static void __exit facility_exit(void)
+{
+	int err;
+
+	err = ltt_facility_dynamic_unregister(LTT_FACILITY_SYMBOL);
+	if(err != 0)
+		printk(KERN_ERR "LTT : Error in unregistering facility.\n");
+
+}
+
+module_init(facility_init)
+module_exit(facility_exit)
+
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION("Linux Trace Toolkit Facility");
+
+#endif //MODULE
+
+#endif //CONFIG_LTT
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-fs.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-fs.h
--- linux-2.6.14.5/ltt/ltt-facility-loader-fs.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-fs.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,20 @@
+#ifndef _LTT_FACILITY_LOADER_FS_H_
+#define _LTT_FACILITY_LOADER_FS_H_
+
+#ifdef CONFIG_LTT
+
+#include <linux/ltt-facilities.h>
+#include <linux/ltt/ltt-facility-id-fs.h>
+
+ltt_facility_t	ltt_facility_fs;
+ltt_facility_t	ltt_facility_fs_40A645EC;
+
+#define LTT_FACILITY_SYMBOL							ltt_facility_fs
+#define LTT_FACILITY_CHECKSUM_SYMBOL		ltt_facility_fs_40A645EC
+#define LTT_FACILITY_CHECKSUM						0x40A645EC
+#define LTT_FACILITY_NAME								"fs"
+#define LTT_FACILITY_NUM_EVENTS					facility_fs_num_events
+
+#endif //CONFIG_LTT
+
+#endif //_LTT_FACILITY_LOADER_FS_H_
